package Board;
################################################################
# Board

# 2002/01/27 Yoichi Imai <yoichi@silver-forest.com>

# Copyright (C) 2002 Yoichi Imai <yoichi@silver-forest.com>

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# $Id: Board.pm,v 1.5 2002/02/03 04:55:21 bonaim Exp $
################################################################

use strict;
use vars qw($UseBoard $UnDeletableKey $ThreadsPerPage $MaxArticle $BoardData $HnsPath $RecentView $RecentTime $ReadStr $WriteStr $LinkStr $Version %ArticleNum $FieldMaxLen $URLMaxLen $BodyMaxLen $CSSFile $Title $RecentTime);

$Version = "0.0.9";

$UseBoard = 0;

$UnDeletableKey = 'undeletable';
$HnsPath = './index.cgi';
$BoardData = 'boarddata.txt';

$ThreadsPerPage = 5;
$MaxArticle = 100;
$RecentView = 10;
$FieldMaxLen = 100;
$URLMaxLen = 150;
$BodyMaxLen = 2000;

$RecentTime = 2 * 24 * 60 * 60;

$ReadStr = 'Read More... (%num)';
$WriteStr = 'Post message...';
$LinkStr = '<div align="right">( %readstr | %writestr )</div>';

$CSSFile = '';
$Title = 'Board';

%ArticleNum = ();

sub read_board_data()
{
  return unless $UseBoard;

  open(FH, $BoardData) || die "Can't open BoardData file.";
  foreach (<FH>) {
    my @list = split(/\t/, $_);
    if($list[0] ne '' && $list[3] ne '' && $list[2] ne 'root') {
     $ArticleNum{$list[3]}++;
    }
  }
  close(FH);
}

sub get_linkstr($)
{
  return "" unless $UseBoard;

  my ($daydata) = shift;
  my $num = $ArticleNum{$daydata};
  my $readstr = $ReadStr;
  my $writestr = $WriteStr;
  my $linkstr = $LinkStr;

  # readstr
  $num = 0 if ($num eq '');
  $readstr =~ s/%num/$num/g;
  if ($num != 0) {
    $readstr = qq(<a href="board.cgi?act=diary&amp;diary=${daydata}">) . $readstr . '</a>';
  }
  # writestr
  $writestr = qq(<a href="board.cgi?act=write&amp;diary=${daydata}">) . $writestr . '</a>';

  # linkstr
  $linkstr =~ s/%readstr/$readstr/g;
  $linkstr =~ s/%writestr/$writestr/g;

  return $linkstr;
}

1;
