#!/usr/local/bin/wish8.0jp

# HyperNikkiSystem hnf editor (Project KAWASARI)
# version 0.04
# 1998/12/8  Ken-ichi HASHIMOTO <ken@h14m.org>

# Copyright (C) 1998  Ken-ich HASHIMOTO, HyperNikkiSystem Project 

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

set diaryDir ~/diary
# scp + .shost 
set SCP /usr/local/bin/scp
set SHOST inaguma@i21x12.fuis.fukui-u.ac.jp
set REMOTEDIR ~/diary

# ⤷ ʬʤС ʬǤʤʤС
#set filedir /
set filedir /[exec date +%Y]/

set editBoxBG black
set editBoxFG white
set editBoxInsertBG white
set editBoxNomalTag "white"
set editBoxCommandTag "cyan"
set editBoxUrlTag "yellow"
set editBoxStringTag "green"
set editBoxReturnTag "green"

set editBoxWidth 80
set editBoxHeight 20

## Ķեɤ߹

if { [file exists ~/.hnfedit] } {
#    puts [file type ~/.hnfedit]
    if { [file type ~/.hnfedit] == "directory" } {
	if { [file exists ~/.hnfedit/init.tcl] } {
	    source ~/.hnfedit/init.tcl
	    puts "source ~/.hnfedit/init.tcl"
	}
	if { [file exists ~/.hnfedit/editenv.tcl] } {
	    source ~/.hnfedit/editenv.tcl
	    puts "source ~/.hnfedit/editenv.tcl"
	}
    }
}

set filename d[exec date +%Y%m%d].hnf

###
### You DON'T have to change below
###
set upflag ""
set modifedText "modifed"

frame .menubar -relief raised -bd 2
frame .info
frame .editbox
frame .action

# ˥塼ʬ
# Fileʬ
menubutton .menubar.file -text File -underline 0 -menu .menubar.file.menu
menu .menubar.file.menu
.menubar.file.menu add command -label New \
	-accelerator "Alt+n" -command {
    .editbox.box delete 1.0 end
}
.menubar.file.menu add command -label {Load Today} \
	-accelerator "Alt+o" -command {
    set todayfilename d[exec date +%Y%m%d].hnf
    if { [file exists $diaryDir$filedir$todayfilename] == 1 } {
	set filename $todayfilename
	loadFile .editbox.box $diaryDir$filedir$filename
    } else { loadFiles .editbox.box $diaryDir$filedir }
}
.menubar.file.menu add command -label {Load as..}\
	-accelerator "Alt+l" -command {
    loadFiles .editbox.box $diaryDir$filedir 
}
.menubar.file.menu add command -label Save \
	-accelerator "Ctrl+s" -command {
    saveFile .editbox.box $diaryDir$filedir$filename
}
.menubar.file.menu add command -label {Save as..} \
	-accelerator "Alt+s" -command {
    saveFiles .editbox.box $diaryDir$filedir$filename
}
.menubar.file.menu add command -label {Close} \
	-accelerator "Alt+w" -command {
    .editbox.box delete 1.0 end
}

.menubar.file.menu add separator
.menubar.file.menu add command -label Exit \
	-accelerator "Ctrl+q" -command {
    destroy .
}
pack .menubar.file -side left -in .menubar

# Editʬ
menubutton .menubar.edit -text Edit -underline 0 -menu .menubar.edit.menu
menu .menubar.edit.menu
.menubar.edit.menu add command -label Copy \
	-accelerator "Alt+c" -command clipCopy
.menubar.edit.menu add command -label Cut  \
	-accelerator "Alt+x" -command clipCut
.menubar.edit.menu add command -label Paste \
	-accelerator "Alt+v" -command clipPaste
pack .menubar.edit -side left -in .menubar

# ޤ
menubutton .menubar.help -text "Help" -underline 0 -menu .menubar.help.menu
menu .menubar.help.menu
.menubar.help.menu add command -label {Help}\
	-accelerator "Alt+p" -command helpWindow
.menubar.help.menu add command -label {About hnfedit...} \
	-accelerator "Alt+a" -command versionWindow
pack .menubar.help -side right -in .menubar

tk_menuBar .menubar .menubar.file .menubar.edit .menubar.help
focus .menubar 

# ɽʬ
label .info.label -text "File:"
entry .info.filename -textvariable filename
entry .info.modifed -textvariable upflag
pack .info.label .info.filename .info.modifed -side left -in .info
.info.filename config -state disabled
.info.modifed config -state disabled

# ޥɥǥʬ
toplevel .comPanel
#frame .comPanel

# NEW ޥ
frame .comPanel.new -relief groove -borderwidth 5
frame .comPanel.newM -relief groove -borderwidth 2
frame .comPanel.newO -relief groove -borderwidth 2
label .comPanel.new.ltitle -text "NEW section"
label .comPanel.newM.ltitle -text "Title"
label .comPanel.newO.lurl -text "URL"
label .comPanel.newO.lcat -text "Category"
entry .comPanel.newM.etitle -textvariable comPanelVal(newTitle) -width 60
entry .comPanel.newO.eurl -textvariable comPanelVal(newUrl) -width 40
entry .comPanel.newO.ecat -textvariable comPanelVal(newCat) -width 10
button .comPanel.newM.ok -text "OK" -command {
    if { $comPanelVal(newTitle) != "" } {
	if { $comPanelVal(newCat) != "" } {
	    .editbox.box insert insert "CAT" commandTag
	    .editbox.box insert insert " "
	    .editbox.box insert insert "$comPanelVal(newCat)\n" stringTag
	}
	if { $comPanelVal(newUrl) != "" } {
	    .editbox.box insert insert "LNEW" commandTag
	    .editbox.box insert insert " "
	    .editbox.box insert insert "$comPanelVal(newUrl) " urlTag
	    .editbox.box insert insert "$comPanelVal(newTitle)\n" stringTag
	} else {
	    .editbox.box insert insert "NEW" commandTag
	    .editbox.box insert insert " "
	    .editbox.box insert insert "$comPanelVal(newTitle)\n" stringTag
	}
	set comPanelVal(newTitle) ""
	set comPanelVal(newUrl) ""
	set comPanelVal(newCat) ""
    } else {

    }
    focus .editbox.box
}

pack .comPanel.newM.ltitle  -side left -fill x -in .comPanel.newM
pack .comPanel.newM.etitle  -side left -fill x -in .comPanel.newM
pack .comPanel.newM.ok      -side left -fill x -in .comPanel.newM
pack .comPanel.newO.lcat .comPanel.newO.ecat -side left -in .comPanel.newO
pack .comPanel.newO.lurl .comPanel.newO.eurl -side left -in .comPanel.newO
pack .comPanel.new.ltitle .comPanel.newM .comPanel.newO -fill x -in .comPanel.new
pack .comPanel.new -fill x -in .comPanel


# SUB ޥ
frame .comPanel.sub -relief groove -borderwidth 5
frame .comPanel.subM -relief groove -borderwidth 2
frame .comPanel.subO -relief groove -borderwidth 2
label .comPanel.sub.ltitle -text "SUB section"
label .comPanel.subM.ltitle -text "Title"
label .comPanel.subO.lurl -text "URL"
label .comPanel.subO.lcat -text "Category"
entry .comPanel.subM.etitle -textvariable comPanelVal(subTitle) -width 60
entry .comPanel.subO.eurl -textvariable comPanelVal(subUrl) -width 40
button .comPanel.subM.ok -text "OK" -command {
    if { $comPanelVal(subTitle) != "" } {
	if { $comPanelVal(subUrl) != "" } {
	    .editbox.box insert insert "LSUB" commandTag
	    .editbox.box insert insert " "
	    .editbox.box insert insert "$comPanelVal(subUrl) " urlTag
	    .editbox.box insert insert "$comPanelVal(subTitle)\n" stringTag
	} else {
	    .editbox.box insert insert "SUB" commandTag
	    .editbox.box insert insert " "
	    .editbox.box insert insert "$comPanelVal(subTitle)\n" stringTag
	    set comPanelVal(subTitle) ""
	    set comPanelVal(subUrl) ""
	    focus .editbox.box
	}
    } else {

    }
}

pack .comPanel.subM.ltitle  -side left -fill x -in .comPanel.subM
pack .comPanel.subM.etitle  -side left -fill x -in .comPanel.subM
pack .comPanel.subM.ok      -side left -fill x -in .comPanel.subM
pack .comPanel.subO.lurl .comPanel.subO.eurl -side left -in .comPanel.subO
pack .comPanel.sub.ltitle .comPanel.subM .comPanel.subO -fill x -in .comPanel.sub
pack .comPanel.sub -fill x -in .comPanel

# LINK , URL ޥ
frame .comPanel.link -relief groove -borderwidth 5
frame .comPanel.linkM -relief groove 
frame .comPanel.linkO -relief groove 
label .comPanel.link.ltitle -text "LINK URL command"
label .comPanel.linkM.ltitle -text "Title"
label .comPanel.linkO.lurl -text "URL"
entry .comPanel.linkM.etitle -textvariable comPanelVal(linkTitle) -width 60
entry .comPanel.linkO.eurl -textvariable comPanelVal(linkUrl) -width 40
button .comPanel.linkO.link -text "LINK" -command {
    if { ($comPanelVal(linkTitle) != "")&&($comPanelVal(linkUrl) != "") } {
	.editbox.box insert insert "LINK" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$comPanelVal(linkUrl) " urlTag
	.editbox.box insert insert "$comPanelVal(linkTitle)\n" stringTag
    } else {

    }
    set comPanelVal(linkTitle) ""
    set comPanelVal(linkUrl) ""
    focus .editbox.box
}
button .comPanel.linkO.url -text "URL" -command {
    if { ($comPanelVal(linkTitle) != "")&&($comPanelVal(linkUrl) != "") } {
	.editbox.box insert insert "URL" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$comPanelVal(linkUrl) " urlTag
	.editbox.box insert insert "$comPanelVal(linkTitle)\n" stringTag
	set comPanelVal(linkTitle) ""
	set comPanelVal(linkUrl) ""
	focus .editbox.box
    } else {

    }
}

pack .comPanel.linkM.ltitle  -side left -fill x -in .comPanel.linkM
pack .comPanel.linkM.etitle  -side left -fill x -in .comPanel.linkM
pack .comPanel.linkO.lurl .comPanel.linkO.eurl -side left -in .comPanel.linkO
pack .comPanel.linkO.link     -side left -fill x -in .comPanel.linkO
pack .comPanel.linkO.url      -side left -fill x -in .comPanel.linkO
pack .comPanel.link.ltitle .comPanel.linkM .comPanel.linkO -fill x -in .comPanel.link
pack .comPanel.link -fill x -in .comPanel



# ǥʬ
text .editbox.box -height $editBoxHeight -width $editBoxWidth \
	-yscroll ".editbox.yscroll set"
scrollbar .editbox.yscroll -command ".editbox.box yview"
.editbox.box configure -bg $editBoxBG -fg $editBoxFG \
	-insertbackground $editBoxInsertBG
.editbox.box tag configure nomalTag -foreground $editBoxNomalTag
.editbox.box tag configure commandTag -foreground $editBoxCommandTag
.editbox.box tag configure urlTag -foreground $editBoxUrlTag
.editbox.box tag configure stringTag -foreground $editBoxStringTag
.editbox.box tag configure returnTag -foreground $editBoxReturnTag

bind .editbox.box <Control-l> {
    set upflag $modifedText
    allColor .editbox.box
} 
bind .editbox.box <Return> { 
    set upflag $modifedText
    set xy [.editbox.box index insert]
    set y [string range $xy 0 [expr [string first "." $xy]-1]]
    lineColor .editbox.box $y
}
bind .editbox.box <Any-KeyRelease> { 
    set tmp [string length %A]
#    puts "length $tmp {%%A=%A %%K=%K}"
    if { $tmp == 1 } {
	set upflag $modifedText
    }
}

bind .editbox.box <Shift-Return> { 
    set upflag $modifedText
    .editbox.box insert insert "~"
    set xy [.editbox.box index insert]
    set y [string range $xy 0 [expr [string first "." $xy]-1]]
    lineColor .editbox.box $y
}


# ѥͥ
frame .editbox.panel
frame .editbox.panel.left
frame .editbox.panel.right
button .editbox.panel.new -text NEW -command {
    set ret [DialogPromptT NEW ȥ]
    if { $ret != "" } {
	.editbox.box insert insert "NEW" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.sub -text SUB -command {
    set ret [DialogPromptT SUB ȥ]
    if { $ret != "" } {
	.editbox.box insert insert "SUB" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.lnew -text LNEW -command {
    set ret [DialogPromptUT LNEW URL ȥ]
    if { $ret != "" } {
	.editbox.box insert insert "LNEW" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.lsub -text LSUB -command {
    set ret [DialogPromptUT LSUB URL ȥ]
    if { $ret != "" } {
	.editbox.box insert insert "LSUB" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.link -text LINK -command {
    set ret [DialogPromptUT LINK URL caption]
    if { $ret != "" } {
	.editbox.box insert insert "LINK" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.url -text URL -command {
    set ret [DialogPromptUT URL URL caption]
    if { $ret != "" } {
	.editbox.box insert insert "URL" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.strike -text STRIKE -command {
    set ret [DialogPromptT STRIKE ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "STRIKE" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.lstrike -text LSTRIKE -command {
    set ret [DialogPromptUT LSTRIKE URL ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "LSTRIKE" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.strong -text STRONG -command {
    set ret [DialogPromptT STRONG ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "STRONG" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.font -text FONT -command {
    set ret [DialogPromptUT FONT ° ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "FONT" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.ul -text UL -command {
    .editbox.box insert insert "UL\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/UL\n" commandTag
    focus .editbox.box
}

button .editbox.panel.ol -text OL -command {
    .editbox.box insert insert "OL\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/OL\n" commandTag
    focus .editbox.box
}

button .editbox.panel.dl -text DL -command {
    .editbox.box insert insert "DL\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/DL\n" commandTag
    focus .editbox.box
}

button .editbox.panel.li -text LI -command {
    set ret [DialogPromptT LI ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "LI" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}
button .editbox.panel.dd -text DD -command {
    set ret [DialogPromptT DD ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "DD" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}
button .editbox.panel.dt -text DT -command {
    set ret [DialogPromptT DT ʸ]
    if { $ret != "" } {
	.editbox.box insert insert "DT" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}

button .editbox.panel.pre -text PRE -command {
    .editbox.box insert insert "PRE\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/PRE\n" commandTag
    focus .editbox.box
}

button .editbox.panel.cite -text CITE -command {
    .editbox.box insert insert "CITE\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/CITE\n" commandTag
    focus .editbox.box
}

button .editbox.panel.fn -text FN -command {
    .editbox.box insert insert "FN\n" commandTag
    .editbox.box insert insert "\n"
    .editbox.box insert insert "/FN\n" commandTag
    focus .editbox.box
}

button .editbox.panel.cat -text CAT -command {
    set ret [DialogPromptT CAT ƥ̾]
    if { $ret != "" } {
	.editbox.box insert insert "CAT" commandTag
	.editbox.box insert insert " "
	.editbox.box insert insert "$ret\n" stringTag
    }
    focus .editbox.box
}


pack .editbox.panel.new -fill x -in .editbox.panel.left
pack .editbox.panel.sub -fill x -in .editbox.panel.left
pack .editbox.panel.link -fill x -in .editbox.panel.left
pack .editbox.panel.strike -fill x -in .editbox.panel.left
pack .editbox.panel.strong -fill x -in .editbox.panel.left
pack .editbox.panel.ul -fill x -in .editbox.panel.left
pack .editbox.panel.ol -fill x -in .editbox.panel.left
pack .editbox.panel.dl -fill x -in .editbox.panel.left
pack .editbox.panel.pre -fill x -in .editbox.panel.left
pack .editbox.panel.fn -fill x -in .editbox.panel.left

pack .editbox.panel.lnew -fill x -in .editbox.panel.right
pack .editbox.panel.lsub -fill x -in .editbox.panel.right
pack .editbox.panel.url -fill x -in .editbox.panel.right
pack .editbox.panel.lstrike -fill x -in .editbox.panel.right
pack .editbox.panel.font -fill x -in .editbox.panel.right
pack .editbox.panel.li -fill x -in .editbox.panel.right
pack .editbox.panel.dt -fill x -in .editbox.panel.right
pack .editbox.panel.dd -fill x -in .editbox.panel.right
pack .editbox.panel.cite -fill x -in .editbox.panel.right
pack .editbox.panel.cat -fill x -in .editbox.panel.right

pack .editbox.panel.left .editbox.panel.right -side left -in .editbox.panel

# ǥʬ
#pack .editbox.panel -side right -in .editbox
pack .editbox.yscroll -side right -fill y -in .editbox
pack .editbox.box -in .editbox


# ʬ
button .action.quit -text quit -command { destroy . }
button .action.load -text load -command { 
    set todayfilename d[exec date +%Y%m%d].hnf
    if { [file exists $diaryDir$filedir$todayfilename] == 1 } {
	set filename $todayfilename
	loadFile .editbox.box $diaryDir$filedir$filename
    }
}
button .action.save -text save -command {
    saveFile .editbox.box $diaryDir$filedir$filename
}
button .action.scp -text scp -command {
    scpFile .editbox.box $diaryDir$filedir$filename $SHOST:$REMOTEDIR$filedir $SCP
}

button .action.setup -text Setup -command {
    setupProc
}

button .action.saveT -text test -command {
    set xy [.editbox.box index insert]
    set y [string range $xy 0 [expr [string first "." $xy]-1]]
    lineColor .editbox.box $y
#    puts "upflag = $upflag"
}


pack .action.load .action.save .action.scp .action.quit -side left -in .action
#pack .action.saveT

bind Text <Shift-space> {kinput_start %W over}
bind Entry <Shift-space> {kinput_start %W over}


# ǽŪʲ̹
pack .menubar -side top -fill x
pack .info .editbox .action 


#### ؿ

# ɤ߹ߴؿ
proc loadFile {text file} {
    global upflag
    $text delete 1.0 end
    set f [open $file]
    while { ![eof $f] } {
	$text insert end [read $f 4096]
    }
    close $f
    allColor $text
    set upflag ""
}

proc loadFiles {text file} {
    global upflag filename
    set ftypes {
	{"hns files" {.hnf}}
	{"All files"  *}
    }
    set fname [tk_getOpenFile -filetypes $ftypes -parent $text \
	    -initialdir $file ]
    if { $fname == "" } {
	return
    } else {
	$text delete 1.0 end
	set f [ open $fname ]
	while { ![eof $f] } {
	    $text insert end [read $f 4096]
	}
	close $f

    regexp {(d[0-9]*.hnf)$} $fname filename

    }
    allColor $text
    set upflag ""
}

# ¸ؿ
proc saveFile {text file} {
    global upflag
    set f [ open $file "w" ]
    puts -nonewline $f [$text get 0.0 end]
    close $f
    set upflag ""
}
proc saveFiles {text file} {
    global upflag filename
    set ftypes {
	{"hns files" {.hnf}}
	{"All files"  *}
    }
    set fname [tk_getSaveFile -filetypes $ftypes -parent $text \
	    -initialdir $file ]
    if { $fname == "" } {
	return
    } else {
	set f [ open $fname "w" ]
	puts -nonewline $f [$text get 0.0 end]
	close $f
	regexp {(d[0-9]*.hnf)$} $fname filename
	set upflag ""
    }
}

# scp ؿ
proc scpFile { text file file2 scp}  {
    global upflag modifedText
    if { $upflag == $modifedText } {
	saveFile $text $file
    }
    exec $scp $file $file2
}
# ƤοŤ
proc allColor { text } {
    set xy [$text index end]
    set e [string range $xy 0 [expr [string first "." $xy]-1]]
    if {$e > 1} {
	set i 1
	while {$i < $e} {
	    lineColor $text $i
	    incr i
	}
    }
}

# 1ԤĤ
proc lineColor { text lineNo } {
    set lineString [ $text get $lineNo.0 $lineNo.end ]
    set cPoint(0) [string length [lindex $lineString 0]]
    set cPoint(1) [expr [string length [lindex $lineString 1]] \
	    + $cPoint(0) + 1]
    set cPoint(2) [expr [string length [lindex $lineString 2]] \
	    + $cPoint(1) + 1]
    set cPoint(3) [expr [string length [lindex $lineString 3]] \
	    + $cPoint(2) + 1]
    set cPoint(4) [expr [string length [lindex $lineString 4]] \
	    + $cPoint(3) + 1]
    set cPoint(5) [expr [string length [lindex $lineString 5]] \
	    + $cPoint(4) + 1]

    switch -regexp -- [lindex $lineString 0] {
	^LNEW|^LSUB|^LSTRIKE|^LIMG {
	    $text tag add commandTag $lineNo.0 $lineNo.$cPoint(0)
	    $text tag add urlTag "$lineNo.$cPoint(0) +1 char" \
		    $lineNo.$cPoint(1)
	    $text tag add stringTag "$lineNo.$cPoint(1) +1 char" $lineNo.end
	}
	^LINK|^URL {
	    $text tag add commandTag $lineNo.0 $lineNo.$cPoint(0)
	    $text tag add urlTag "$lineNo.$cPoint(0) +1 char" \
		    $lineNo.$cPoint(1)
	    $text tag add stringTag "$lineNo.$cPoint(1) +1 char" $lineNo.end
	}
	^RLINK {
	    $text tag add commandTag $lineNo.0 $lineNo.$cPoint(0)
	    $text tag add urlTag "$lineNo.$cPoint(0) +1 char" \
		    $lineNo.$cPoint(1)
	    $text tag add urlTag "$lineNo.$cPoint(1) +1 char" \
		    $lineNo.$cPoint(2)
	    $text tag add stringTag "$lineNo.$cPoint(2) +1 char" $lineNo.end
	}
	^/?[A-Z]+ { 
	    $text tag add commandTag $lineNo.0 $lineNo.$cPoint(0)
	    $text tag add stringTag "$lineNo.$cPoint(0) +1 char" $lineNo.end
	    # $text tag add [̾] ϰ λ
	    # ϰ $line.0            ( $line ܤ 0 ʸ )
	    # λ $lineNo.$cPoint(0) ( $cPoint(X) Xñνΰ)  
	    # "$lineNo.$cPoint(0) +1 char"
	    #                        lineܤ0ñνΰ + 1ʸ
	}
	default {
	    # ɸ࿧ˤ롣
	    $text tag add nomalTag $lineNo.0 $lineNo.end
	}
    } 

    # ʸ ~ դ
    if { [regexp {~$} $lineString] } {
	$text tag add returnTag "$lineNo.end -1 char" $lineNo.end
    }
}


# ؿ


proc Dialog_Create {top title args} {
	global dialog
	if [winfo exists $top] {
		switch -- [wm state $top] {
			normal {
				# Raise a buried window
				raise $top
			}
			withdrawn -
			iconified {
				# Open and restore geometry
				wm deiconify $top
				catch {wm geometry $top $dialog(geo,$top)}
			}
		}
		return 0
	} else {
		eval {toplevel $top} $args
		wm title $top $title
		return 1
	}
}
proc Dialog_Wait {top varName {focus {}}} {
	upvar $varName var

	# Poke the variable if the user nukes the window
	bind $top <Destroy> [list set $varName $var]

	# Grab focus for the dialog
	if {[string length $focus] == 0} {
		set focus $top
	}
	set old [focus -displayof $top]
	focus $focus
	catch {tkwait visibility $top}
	catch {grab $top}

	# Wait for the dialog to complete
	tkwait variable $varName
	catch {grab release $top}
	focus $old
}
proc Dialog_Dismiss {top} {
	global dialog
	# Save current size and position
	catch {
		# window may have been deleted
		set dialog(geo,$top) [wm geometry $top]
		wm withdraw $top
	}
}

#proc Dialog_Prompt { string } {
#	global prompt
#	set f .prompt
#	if [Dialog_Create $f "Prompt" -borderwidth 10] {
#		message $f.msg -text $string -aspect 1000
#		entry $f.entry -textvariable prompt(result)
#		set b [frame $f.buttons]
#		pack $f.msg $f.entry $f.buttons -side top -fill x
#		pack $f.entry -pady 5
#		button $b.ok -text OK -command {set prompt(ok) 1}
#		button $b.cancel -text Cancel \
#			-command {set prompt(ok) 0}
#		pack $b.ok -side left
#		pack $b.cancel -side right
#		bind $f.entry <Return> {set prompt(ok) 1 ; break}
#		bind $f.entry <Control-c> {set prompt(ok) 0 ; break}
#	}
#	set prompt(ok) 0
#	Dialog_Wait $f prompt(ok) $f.entry
#	Dialog_Dismiss $f
#	if {$prompt(ok)} {
#		return $prompt(result)
#	} else {
#		return {}
#	}
#}


proc DialogPromptT {wn msg1} {
    global prompt
    set f .p$wn
    set prompt(result) ""
    if [Dialog_Create $f "$wn" -borderwidth 10] {
	message $f.msg -text "$msg1" -aspect 1000
	entry $f.entry -textvariable prompt(result)
	set b [frame $f.buttons]
	pack $f.msg $f.entry $f.buttons -side top -fill x
	pack $f.entry -pady 5
	button $b.ok -text OK -command {set prompt(ok) 1}
	button $b.cancel -text Cancel \
		-command {set prompt(ok) 0}
	pack $b.ok -side left
	pack $b.cancel -side right
	bind $f.entry <Return> {set prompt(ok) 1 ; break}
	bind $f.entry <Control-c> {set prompt(ok) 0 ; break}
    }
    set prompt(ok) 0
    Dialog_Wait $f prompt(ok) $f.entry
    Dialog_Dismiss $f
    if {$prompt(ok)} {
	return $prompt(result)
    } else {
	return {}
    }
}

proc DialogPromptUT {wn msg1 msg2} {
    global prompt
    set f .p$wn
    set prompt(result) ""
    set prompt(url) ""
    set prompt(ok) 0
    if [Dialog_Create $f "$wn" -borderwidth 10] {
	message $f.msg1 -text "$msg1" -aspect 1000
	entry $f.entry1 -textvariable prompt(url)
	message $f.msg2 -text "$msg2" -aspect 1000
	entry $f.entry2 -textvariable prompt(result)
	set b [frame $f.buttons]
	pack $f.msg1 $f.entry1 $f.msg2 $f.entry2 $f.buttons -side top -fill x
	pack $f.entry1 $f.entry2 -pady 5
	button $b.ok -text OK -command {set prompt(ok) 1}
	button $b.cancel -text Cancel \
		-command {set prompt(ok) 0}
	pack $b.ok -side left
	pack $b.cancel -side right
	bind $f.entry1 <Control-c> {set prompt(ok) 0 ; break}
	bind $f.entry2 <Return> {set prompt(ok) 1 ; break}
	bind $f.entry2 <Control-c> {set prompt(ok) 0 ; break}
    }
    set prompt(ok) 0
    Dialog_Wait $f prompt(ok) $f.entry1
    Dialog_Dismiss $f
    if {$prompt(ok)} {
	return "$prompt(url) $prompt(result)"
    } else {
	return {}
    }
}

proc setupProc { } {
    global setupProc
    set f .setupProc
    setupProc
    if [Dialog_Create $f "Setup" -borderwidth 10] {
	label $f.edBg -text 
	label $f.edFg
	label $f.edInsBg
    }
    set prompt(ok) 0
    Dialog_Wait $f prompt(ok) $f.entry1
    Dialog_Dismiss $f
    if {$prompt(ok)} {
	return "$prompt(url) $prompt(result)"
    } else {
	return {}
    }
}

#
# åץܡɤ˥ԡΤ

proc clipCopy {} {
    global upflag
    set w(text) .editbox.box
    if { [ selection own ] == $w(text) } {
	clipboard clear
	catch { clipboard append [selection get] }
    }
    set upflag ""
}

#
# ڤä㤦

proc clipCut {} {
    global upflag modifedText
    set w(text) .editbox.box
    if { [ selection own ] == $w(text) } {
	clipboard clear
	catch {
	    clipboard append [ selection get ]
	    $w(text) delete sel.first sel.last
	}
    }
    set upflag $modifedText
}

#
# åץܡɤƤŽդΤ

proc clipPaste {} {
    global upflag modifedText
    set w(text) .editbox.box
    catch { set clip [ selection get -selection CLIPBOARD ] }
    if { [ selection own ] == $w(text) } {
	catch { $w(text) delete sel.first sel.last }
	set idex [ $w(text) index insert ]
	catch { $w(text) insert $idex $clip }
    }
    set upflag $modifedText
}

#
# Ф hnfedit

proc versionWindow {} {
    toplevel .vwindow
    wm title .vwindow {About hnfedit}
    canvas .vwindow.can -background black -width 275 -height 55
    image create photo mascot -file heditico.gif
    .vwindow.can create image 40 20 -image mascot
    .vwindow.can create text 120 16 -text "hnfedit ver0.0x" -fill white
    .vwindow.can create text 130 42 -text \
	    "Copyright(c) by HyperNikkiSystem Project" -fill white
    button .vwindow.ok -text "OK" -command {destroy .vwindow}

    pack .vwindow.can .vwindow.ok -side top -fill both -expand yes
}

#
# ؤפ

proc helpWindow {} {
    toplevel .hwindow
    wm title .hwindow {Help}
    message .hwindow.mes -text "ʤäƤʤΡ" \
	    -bg black -fg white -width 100
    button .hwindow.ok -text "OK" -command {destroy .hwindow}
    pack .hwindow.mes .hwindow.ok
}

#
# 饷áȥåȤ

bind all <Alt-c> clipCopy
bind all <Alt-x> clipCut
bind all <Alt-v> clipPaste
bind all <Alt-n> {
    .editbox.box delete 1.0 end 
    set upflag ""
}
bind all <Alt-o> { 
    set todayfilename d[exec date +%Y%m%d].hnf
    if { [file exists $diaryDir$filedir$todayfilename] == 1 } {
	set filename $todayfilename
	loadFile .editbox.box $diaryDir$filedir$filename
    } else { loadFiles .editbox.box $diaryDir$filedir }
    set upflag $modifedText
}
bind all <Alt-l> { 
    loadFiles .editbox.box $diaryDir$filedir 
    set upflag $modifedText
}

bind all <Control-s> {
    saveFile .editbox.box $diaryDir$filedir$filename 
    set upflag ""
}
bind all <Alt-s> {
    saveFiles .editbox.box $diaryDir$filedir$filename
    set upflag ""
}
bind all <Alt-w> {
    .editbox.box delete 1.0 end 
    set upflag ""
}

bind all <Control-q> { destroy . } 


bind all <Alt-a> versionWindow
bind all <Alt-p> helpWindow
#### ư

# ư˺Υե뤬ʤɤ߹
if { [file exists $diaryDir$filedir$filename] == 1 } {
    loadFile .editbox.box $diaryDir$filedir$filename
}

