#!%PERL_PATH%

# HyperNikkiSystem Title List
# version 0.0.8
# 1999/3/14  Kenji Suzuki <kenji@h14m.org>

$version = "0.0.8";

# Special Thanks:
# Akihiro Arisawa <ari@nijino.com>

# Copyright (C) 1998,1999  Kenji Suzuki, HyperNikkiSystem Project

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


$diaryDir = "%DIARYDIR%";
$webDiaryDir = "%HTMLDIR%";
$catDir = $webDiaryDir . "/cat";
$catFile = $catDir . "/cat.txt";

$NKF = "%NKF_PATH%";
$NKF_USE = 1; # 1 -> Use, 0 -> No Use


# global values
my ($arg, @CAT, @SELECTED_CAT, %cat, $dispOrder, @filelist, @NEW, $hnf);


&main;


sub getArg () {
  $arg = $ENV{'QUERY_STRING'};
  $arg =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C", hex($1))/ge;
 
  $arg =~ s/CAT=([^&]*)/push(@SELECTED_CAT, $1);"";/ge;
  foreach (@SELECTED_CAT) {
    if ($_ eq "ALL") {
      undef @SELECTED_CAT;
      $SELECTED_CAT[0] = "ALL";
    }
  }

  $arg =~ s/\D*(\d+)\D*/$1/;
  if ($arg =~ /(\d\d\d\d)(.*)/) {
    $year = $1; 
    $dispOrder = 1; # in late order
  }
  else {
    $arg = $year . $mon;
    $dispOrder = -1; # in reverse order
  } 
}


sub main () {
  my (@tmp);

  &getTime;
  &readCatFile;
  &getArg;
  &html_header;

  if (-d $diaryDir . "/" . $year) {
    &getFileList($diaryDir . "/" . $year);
  }

  &getFileList($diaryDir);

  if ($dispOrder == 1) {
    @tmp = sort @filelist;
  }
  else {
    @tmp = reverse sort @filelist;
  }

  @filelist = @tmp;

  foreach $file (@filelist) {
    &readHnf($file);
    &getNew(@hnfs);
  }

  if ($SELECTED_CAT[0] eq "ALL") {
    @SELECTED_CAT = keys %CAT;
  } 
  if (defined(@SELECTED_CAT)) {
    foreach $cat (@SELECTED_CAT) {
      print "<h3>";

      $enc_cat = $cat;
      $enc_cat =~ s/([^a-zA-Z0-9~\-\_\.\/\:\%])/
                sprintf("%%%02X",ord($1))/ge;

      if (-f $catDir . "/" . $cats{$cat}) {
        print "<img src=\"./cat/$cats{$cat}\" alt=\"$cat\"> <a href=\"./title.cgi?$arg&CAT=$enc_cat\">$cat</a>";
      }
      else {
        print "<a href=\"./title.cgi?$arg&CAT=$enc_cat\">$cat</a>";
      }
      print "</h3>\n";

      foreach $title (@{$CAT{$cat}}) {
        print "$title<br>\n";
      }
    }
  }
  else {
    foreach $title (@NEW) {
      print "$title<br>\n";
    }
  }

  &html_footer;
}


sub html_header {
  print "Content-type: text/html\n\n";
  print "<html>\n<head>\n<title>HNS Title List</title>\n</head>\n";
  print "<body bgcolor=\"#E0E0FF\">\n";
}


sub html_footer {
  print "\n<hr>\n";
  print "HNS Title List-$version, ";
  print "Copyright (c) by ";
  print "<a href=\"http://www.h14m.org/\">HyperNikkiSystem Project</a> ";
  print "1998,1999\n";
  print "</body>\n</html>";
}


sub getFileList ($) {
  my $dir = $_[0];

  opendir DIR, $dir or die "can't open directory: $!";
  @files = grep /d$arg\d{1,4}.hnf$/, readdir DIR;
  closedir DIR;

  push @filelist, @files;

  foreach $file (@files) {
    $filedir{$file} = $dir;
  }
}


sub readHnf ($) {
  my $hnf = $_[0];

  $hnf_ = $filedir{$hnf} . "/" . $hnf; 
  if ($NKF_USE == 1) {
    open (HNF, "$NKF -emXZ1 $hnf_ |") || die "can't open hnf: $!";
  }
  else {
    open (HNF, $hnf_) || die "can't open hnf: $!";
  }

  @hnfs = <HNF>;
  close(HNF);
}


sub getNew (@) {
  my @hnfs = @_;
  my ($i, %TITLE, $linkHi, $link, $date, @cat, $cat);

  $date = $link = $linkHi = $file;
  $link =~ s/d(\d{8}).hnf/$1/;
  $linkHi =~ s/d(\d{7})(\d).hnf/$1/;
  $date =~ s/d(\d.*)(\d\d)(\d\d).hnf/$1\/$2\/$3/;

  $i = 1;
  foreach (@hnfs) {
    if (/^CAT (.*)/) {
      @cat = split(' ', $1);
    }
    if (defined(@cat)) {
      if (/^NEW (.*)/) {
	foreach $cat (@cat) {
	  push (@{$CAT{$cat}},
            "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: $1\n");
	}
        undef(@cat);
        push (@NEW, "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: $1\n");
        $i++;
      } 
      elsif (/^LNEW (.*?) (.*)/) {
	foreach $cat (@cat) {
	  push (@{$CAT{$cat}},
            "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: <a href=\"$1\">$2</a>\n");
	}
	undef(@cat);
        push (@NEW,
          "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: <a href=\"$1\">$2</a>\n");
        $i++;
      }
    }
    else {
      if (/^NEW (.*)/) {
        push (@NEW, "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: $1\n");
        $i++;
      }
      if (/^LNEW (.*?) (.*)/) {
        push (@NEW,
          "<a href=\"./?$linkHi#$link$i\">$date#$i</a>: <a href=\"$1\">$2</a>\n");
        $i++;
      }
    }
  }
}

sub getTime () {
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  $year = $year + 1900;
  $mon  = $mon + 1;
  $mday = "0$mday" if $mday < 10;
  $mon  = "0$mon"  if $mon  < 10;
  $sec  = "0$sec"  if $sec  < 10;
  $min  = "0$min"  if $min  < 10;
  $hour = "0$hour" if $min  < 10;
}


sub readCatFile () {
  if (-f $catFile) {
    if ($NKF_USE == 1) {
      open (FILE, "$NKF -emXZ1 $catFile |") || die "can't open $catFile: $!";
    }
    else {
      open(FILE, "$catFile") || die "Can't Open File: $catFile: $!";
    }

    @tmp = <FILE>;
    close(FILE);
  }
  foreach (@tmp) {
    if ($_ =~ /(\S+) (\S+)(.*)/) {
      $cats{$1} = $2;
    }
  }
}

