#!/bin/sh

# Namazu for hns installer
#  for Debian woody
# version 0.0.1
# 2002/1/12  Kenji Suzuki <kenji@h14m.org>
# patch was contributed by Takeshi Komiya <katsuwo@ish.ic.kanagawa-it.ac.jp>

# Copyright (C) 2002  Kenji Suzuki, HyperNikkiSystem Project

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# $Id: setup-deb.sh,v 1.2 2002/01/12 14:04:31 kenji Exp $

# usage:
# ./setup-deb.sh [hns_major_version diary_uri author alias_file index_dir]
# eg:
# ./setup-deb.sh

# Depends: namazu2, namazu2-index-tools
# Suggets: hns2

HNSSETUP=$HOME/.hnssetup2
if [ -f $HNSSETUP ]; then
 eval `cat $HNSSETUP`
fi

DIARYDIR=${DEFDIARY:-"$HOME/diary"}
WEBDIARYDIR=${DEFHTML:-"$HOME/public_html/diary"}

PREFIX=/usr
VERSION=$1
URI=$2
AUTHOR=$3
ALIAS_FILE=$4
INDEX=$5

URI=${URI:-"$DEFURL"}
AUTHOR=${AUTHOR:-"$DEFMAIL"}
PREFIX=${PREFIX:-"/usr/local"}
VERSION=${VERSION:-2}
ALIAS_FILE=${ALIAS_FILE:-"$DIARYDIR/conf/alias.txt"}
INDEX=${INDEX:-"$DIARYDIR/namazu2/index"}


# hns-index2
sed -e "s!%PREFIX%!$PREFIX!g" \
    -e "s!%DIARYDIR%!$DIARYDIR!g" \
            hns-index2.in > hns-index2

# mknmzrc
sed -e "s!%VERSION%!$VERSION!g" \
    -e "s!%URI%!$URI!g" \
    -e "s!%AUTHOR%!$AUTHOR!g" \
    -e "s!%ALIAS_FILE%!$ALIAS_FILE!g" \
            mknmzrc.in > mknmzrc

# namazurc
sed -e "s!%INDEX%!$INDEX!g" \
            namazurc.in > namazurc

# NMZ.head
sed -e "s!%AUTHOR%!$AUTHOR!g" \
    -e "s!%URI%!$URI!g" \
            template/NMZ.head.ja.in > template/NMZ.head.ja
sed -e "s!%AUTHOR%!$AUTHOR!g" \
    -e "s!%URI%!$URI!g" \
            template/NMZ.head.in > template/NMZ.head

# install
if [ ! -d $DIARYDIR ]; then \
    mkdir -p $DIARYDIR; \
    echo "mkdir -p $DIARYDIR"; \
fi
if [ ! -d $WEBDIARYDIR ]; then \
    mkdir -p $WEBDIARYDIR; \
    echo "mkdir -p $WEBDIARYDIR"; \
fi
if [ ! -d $DIARYDIR/namazu2 ]; then \
    mkdir -p $DIARYDIR/namazu2; \
    echo "mkdir -p $DIARYDIR/namazu2"; \
fi
if [ ! -d $DIARYDIR/bin ]; then \
    mkdir -p $DIARYDIR/bin; \
    echo "mkdir -p $DIARYDIR/bin"; \
fi
if [ ! -d $DIARYDIR/namazu2/etc ]; then \
    mkdir -p $DIARYDIR/namazu2/etc; \
    echo "mkdir -p $DIARYDIR/namazu2/etc"; \
fi
if [ ! -d $INDEX ]; then \
    mkdir -p $INDEX; \
    echo "mkdir -p $INDEX"; \
fi
if [ ! -d $DIARYDIR/namazu2/template ]; then \
    mkdir -p $DIARYDIR/namazu2/template; \
    echo "mkdir -p $DIARYDIR/namazu2/template"; \
fi

cp -p hns-index2 $DIARYDIR/bin
echo "cp -p hns-index2 $DIARYDIR/bin/"
chmod +x $DIARYDIR/bin/hns-index2
cp -p $PREFIX/lib/cgi-bin/namazu.cgi $WEBDIARYDIR/namazu.cgi
echo "cp -p $PREFIX/lib/cgi-bin/namazu.cgi $WEBDIARYDIR/namazu.cgi"
cp mknmzrc $DIARYDIR/namazu2/etc
echo "cp mknmzrc $DIARYDIR/namazu2/etc/"
cp namazurc $WEBDIARYDIR/.namazurc
echo "cp namazurc $WEBDIARYDIR/.namazurc"
cp -p $PREFIX/share/namazu/template/NMZ.* $DIARYDIR/namazu2/template
cp -p template/NMZ.* $DIARYDIR/namazu2/template
echo "cp -p template/NMZ.* $DIARYDIR/namazu2/template/"
rm $DIARYDIR/namazu2/template/NMZ.*.in

